Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse JDT Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.eclipse.jdt.core
Interface IBuffer

public interface IBuffer

A buffer contains the text contents of a resource. It is not language-specific. The contents may be in the process of being edited, differing from the actual contents of the underlying resource. A buffer has an owner, which is an `IOpenable`. If a buffer does not have an underlying resource, saving the buffer has no effect. Buffers can be read-only.

Note that java model operations that manipulate an `IBuffer` (for example, `IType.createMethod(...)`) ensures that the same line delimiter (either `"\n"` or `"\r"` or `"\r\n"`) is used across the whole buffer. Thus these operations may change the line delimiter(s) included in the string to be append, or replaced. However implementers of this interface should be aware that other clients of `IBuffer` might not do such transformations beforehand.

This interface may be implemented by clients.

Method Summary
`void` | `addBufferChangedListener(IBufferChangedListener listener)` Adds the given listener for changes to this buffer.
`void` | `append(char[] text)` Appends the given character array to the contents of the buffer.
`void` | `append(String text)` Appends the given string to the contents of the buffer.
`void` | `close()` Closes the buffer.
`char` | `getChar(int position)` Returns the character at the given position in this buffer.
`char[]` | `getCharacters()` Returns the contents of this buffer as a character array, or `null` if the buffer has not been initialized.
`String` | `getContents()` Returns the contents of this buffer as a `String`.
`int` | `getLength()` Returns number of characters stored in this buffer.
`IOpenable` | `getOwner()` Returns the Java openable element owning of this buffer.
`String` | `getText(int offset, int length)` Returns the given range of text in this buffer.
`IResource` | `getUnderlyingResource()` Returns the underlying resource for which this buffer was opened, or `null` if this buffer was not opened on a resource.
`boolean` | `hasUnsavedChanges()` Returns whether this buffer has been modified since it was opened or since it was last saved.
`boolean` | `isClosed()` Returns whether this buffer has been closed.
`boolean` | `isReadOnly()` Returns whether this buffer is read-only.
`void` | `removeBufferChangedListener(IBufferChangedListener listener)` Removes the given listener from this buffer.
`void` | `replace(int position, int length, char[] text)` Replaces the given range of characters in this buffer with the given text.
`void` | `replace(int position, int length, String text)` Replaces the given range of characters in this buffer with the given text.
`void` | `save(IProgressMonitor progress, boolean force)` Saves the contents of this buffer to its underlying resource.
`void` | `setContents(char[] contents)` Sets the contents of this buffer to the given character array.
`void` | `setContents(String contents)` Sets the contents of this buffer to the given `String`.

Method Detail

### addBufferChangedListener

    public void addBufferChangedListener(IBufferChangedListener listener)

  Adds the given listener for changes to this buffer. Has no effect if an identical listener is already registered or if the buffer is closed.

  Parameters:
    `listener` - the listener of buffer changes

### append

    public void append(char[] text)

  Appends the given character array to the contents of the buffer. This buffer will now have unsaved changes. Any client can append to the contents of the buffer, not just the owner of the buffer. Reports a buffer changed event.

  Has no effect if this buffer is read-only or if the buffer is closed.

  Parameters:
    `text` - the given character array to append to contents of the buffer

### append

    public void append(String text)

  Appends the given string to the contents of the buffer. This buffer will now have unsaved changes. Any client can append to the contents of the buffer, not just the owner of the buffer. Reports a buffer changed event.

  Has no effect if this buffer is read-only or if the buffer is closed.

  Parameters:
    `text` - the `String` to append to the contents of the buffer

### close

    public void close()

  Closes the buffer. Any unsaved changes are lost. Reports a buffer changed event with a 0 offset and a 0 length. When this event is fired, the buffer should already be closed.

  Further operations on the buffer are not allowed, except for close. If an attempt is made to close an already closed buffer, the second attempt has no effect.

### getChar

    public char getChar(int position)

  Returns the character at the given position in this buffer.

  The returned value is undefined if the buffer is closed.

  Parameters:
    `position` - a zero-based source offset in this buffer
  Returns:
    the character at the given position in this buffer

### getCharacters

    public char[] getCharacters()

  Returns the contents of this buffer as a character array, or `null` if the buffer has not been initialized.

  Callers should make no assumption about whether the returned character array is or is not the genuine article or a copy. In other words, if the client wishes to change this array, they should make a copy. Likewise, if the client wishes to hang on to the array in its current state, they should make a copy.

  The returned value is undefined if the buffer is closed.

  Returns:
    the characters contained in this buffer

### getContents

    public String getContents()

  Returns the contents of this buffer as a `String`. Like all strings, the result is an immutable value object., It can also answer `null` if the buffer has not been initialized.

  The returned value is undefined if the buffer is closed.

  Returns:
    the contents of this buffer as a `String`

### getLength

    public int getLength()

  Returns number of characters stored in this buffer.

  The returned value is undefined if the buffer is closed.

  Returns:
    the number of characters in this buffer

### getOwner

    public IOpenable getOwner()

  Returns the Java openable element owning of this buffer.

  Returns:
    the openable element owning this buffer

### getText

    public String getText(int offset,
                          int length)

  Returns the given range of text in this buffer.

  The returned value is undefined if the buffer is closed.

  Parameters:
    `offset` - the zero-based starting offset
    `length` - the number of characters to retrieve
  Returns:
    the given range of text in this buffer

### getUnderlyingResource

    public IResource getUnderlyingResource()

  Returns the underlying resource for which this buffer was opened, or `null` if this buffer was not opened on a resource.

  Returns:
    the underlying resource for this buffer, or `null` if none.

### hasUnsavedChanges

    public boolean hasUnsavedChanges()

  Returns whether this buffer has been modified since it was opened or since it was last saved. If a buffer does not have an underlying resource, this method always returns `true`.

  NOTE: when a buffer does not have unsaved changes, the model may decide to close it to claim some memory back. If the associated element needs to be reopened later on, its buffer factory will be requested to create a new buffer.

  Returns:
    a `boolean` indicating presence of unsaved changes (in the absence of any underlying resource, it will always return `true`).

### isClosed

    public boolean isClosed()

  Returns whether this buffer has been closed.

  Returns:
    a `boolean` indicating whether this buffer is closed.

### isReadOnly

    public boolean isReadOnly()

  Returns whether this buffer is read-only.

  Returns:
    a `boolean` indicating whether this buffer is read-only

### removeBufferChangedListener

    public void removeBufferChangedListener(IBufferChangedListener listener)

  Removes the given listener from this buffer. Has no affect if an identical listener is not registered or if the buffer is closed.

  Parameters:
    `listener` - the listener

### replace

    public void replace(int position,
                        int length,
                        char[] text)

  Replaces the given range of characters in this buffer with the given text. `position` and `position + length` must be in the range [0, getLength()]. `length` must not be negative.

  Has no effect if this buffer is read-only or if the buffer is closed.

  Parameters:
    `position` - the zero-based starting position of the affected text range in this buffer
    `length` - the length of the affected text range in this buffer
    `text` - the replacing text as a character array

### replace

    public void replace(int position,
                        int length,
                        String text)

  Replaces the given range of characters in this buffer with the given text. `position` and `position + length` must be in the range [0, getLength()]. `length` must not be negative.

  Has no effect if this buffer is read-only or if the buffer is closed.

  Parameters:
    `position` - the zero-based starting position of the affected text range in this buffer
    `length` - the length of the affected text range in this buffer
    `text` - the replacing text as a `String`

### save

    public void save(IProgressMonitor progress,
                     boolean force)
              throws JavaModelException

  Saves the contents of this buffer to its underlying resource. If successful, this buffer will have no unsaved changes. The buffer is left open. Saving a buffer with no unsaved changes has no effect - the underlying resource is not changed. If the buffer does not have an underlying resource or is read-only, this has no effect.

  The `force` parameter controls how this method deals with cases where the workbench is not completely in sync with the local file system. If `false` is specified, this method will only attempt to overwrite a corresponding file in the local file system provided it is in sync with the workbench. This option ensures there is no unintended data loss; it is the recommended setting. However, if `true` is specified, an attempt will be made to write a corresponding file in the local file system, overwriting any existing one if need be. In either case, if this method succeeds, the resource will be marked as being local (even if it wasn't before).

  Has no effect if this buffer is read-only or if the buffer is closed.

  Parameters:
    `progress` - the progress monitor to notify
    `force` - a `boolean` flag indicating how to deal with resource inconsistencies.
  Throws:
    `JavaModelException` - if an error occurs writing the buffer to the underlying resource
  See Also:
    `IFile.setContents(java.io.InputStream, boolean, boolean, org.eclipse.core.runtime.IProgressMonitor)`

### setContents

    public void setContents(char[] contents)

  Sets the contents of this buffer to the given character array. This buffer will now have unsaved changes. Any client can set the contents of the buffer, not just the owner of the buffer. Reports a buffer changed event.

  Equivalent to `replace(0,getLength(),contents)`.

  Has no effect if this buffer is read-only or if the buffer is closed.

  Parameters:
    `contents` - the new contents of this buffer as a character array

### setContents

    public void setContents(String contents)

  Sets the contents of this buffer to the given `String`. This buffer will now have unsaved changes. Any client can set the contents of the buffer, not just the owner of the buffer. Reports a buffer changed event.

  Equivalent to `replace(0,getLength(),contents)`.

  Has no effect if this buffer is read-only or if the buffer is closed.

  Parameters:
    `contents` - the new contents of this buffer as a `String`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse JDT Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) IBM Corp. and others 2000, 2004. All Rights Reserved.